searchNodes=[{"ref":"ExGcloudPubsubPuller.html","title":"ExGcloudPubsubPuller","type":"module","doc":""},{"ref":"ExGcloudPubsubPuller.html#main/1","title":"ExGcloudPubsubPuller.main/1","type":"function","doc":"Main entrypoint to a pull job. Expects to be given a module that implements the ExGcloudPubsubPuller.PullController behaviour."},{"ref":"ExGcloudPubsubPuller.html#t:pull_controller/0","title":"ExGcloudPubsubPuller.pull_controller/0","type":"type","doc":"A Module that implements the ExGcloudPubsubPuller.PullController behaviour."},{"ref":"ExGcloudPubsubPuller.PullController.html","title":"ExGcloudPubsubPuller.PullController","type":"behaviour","doc":"Implement the behaviour from this module to control pulling from a subscription. Add your controller to the config to ensure it gets run. Examples # config/config.exs: config :my_app, ExGcloudPubsubPuller.Scheduler, schedule: {:extended, &quot;*/5&quot;}, overlap: false, timezone: :utc, jobs: [ cost_job: [ task: {ExGcloudPubsubPuller, :main, [CostPullController]} ], usage_job: [ task: {ExGcloudPubsubPuller, :main, [UsagePullController]} ] ] # lib/my_app/cost_pull_controller.ex: defmodule CostPullController do @behaviour ExGcloudPubsubPuller.PullController @impl true def subscription_id(), do: &quot;cost-subscription&quot; @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end @impl true def handle_stagnant() do some_function_that_fixes_the_world() end @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;) end # lib/my_app/usage_pull_controller.ex: defmodule UsagePullController do @behaviour ExGcloudPubsubPuller.PullController @impl true def subscription_id(), do: &quot;usage-subscription&quot; @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end @impl true def handle_stagnant() do some_function_that_fixes_the_world() end @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;) end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_message/1","title":"ExGcloudPubsubPuller.PullController.handle_message/1","type":"callback","doc":"Gets called with each message that gets pulled from the subscription. Should return either :ok or :error. If :ok is returned, the message will be acknowledged. If :error is returned, the message will NOT be acknowledged. Examples @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_pull_error/1","title":"ExGcloudPubsubPuller.PullController.handle_pull_error/1","type":"callback","doc":"Gets called if pulling from Google PubSub yields an error. Examples @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;)"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_stagnant/0","title":"ExGcloudPubsubPuller.PullController.handle_stagnant/0","type":"callback","doc":"Gets called if no message has come through the subscription in 30 seconds. Examples @impl true def handle_stagnant() do some_function_that_fixes_the_world() end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:subscription_id/0","title":"ExGcloudPubsubPuller.PullController.subscription_id/0","type":"callback","doc":"Should return the Google PubSub subscription id from which messages will be pulled. Gets called at the start of each job run. Examples @impl true def subscription_id(), do: &quot;my-super-good-subscription&quot;"},{"ref":"ExGcloudPubsubPuller.Scheduler.html","title":"ExGcloudPubsubPuller.Scheduler","type":"module","doc":"Defines a quantum Scheduler. When used, the quantum scheduler expects the :otp_app as option. The :otp_app should point to an OTP application that has the quantum runner configuration. For example, the quantum scheduler: defmodule ExGcloudPubsubPuller.Scheduler do use Quantum.Scheduler, otp_app: ex_gcloud_pubsub_puller end Could be configured with: config ex_gcloud_pubsub_puller, ExGcloudPubsubPuller.Scheduler, jobs: [ {&quot;@daily&quot;, {Backup, :backup, []}, ] Configuration: :timeout - Sometimes, you may come across GenServer timeout errors esp. when you have too many jobs or high load. The default GenServer.call timeout is 5000. :jobs - list of cron jobs to execute :global - When you have a cluster of nodes, you may not want same jobs to be generated on every single node, e.g. jobs involving db changes. In this case, you may choose to run Quantum as a global process, thus preventing same job being run multiple times because of it being generated on multiple nodes. With the following configuration, Quantum will be run as a globally unique process across the cluster. :schedule - Default schedule of new Job :run_strategy - Default Run Strategy of new Job :overlap - Default overlap of new Job, :timezone - Default timezone of new Job"},{"ref":"ExGcloudPubsubPuller.Scheduler.html#activate_job/2","title":"ExGcloudPubsubPuller.Scheduler.activate_job/2","type":"function","doc":"Activates a job by name Callback implementation for Quantum.Scheduler.activate_job/2."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#add_job/2","title":"ExGcloudPubsubPuller.Scheduler.add_job/2","type":"function","doc":"Adds a new job Callback implementation for Quantum.Scheduler.add_job/2."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#config/1","title":"ExGcloudPubsubPuller.Scheduler.config/1","type":"function","doc":"Returns the configuration stored in the :otp_app environment. Callback implementation for Quantum.Scheduler.config/1."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#deactivate_job/2","title":"ExGcloudPubsubPuller.Scheduler.deactivate_job/2","type":"function","doc":"Deactivates a job by name Callback implementation for Quantum.Scheduler.deactivate_job/2."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#delete_all_jobs/1","title":"ExGcloudPubsubPuller.Scheduler.delete_all_jobs/1","type":"function","doc":"Deletes all jobs Callback implementation for Quantum.Scheduler.delete_all_jobs/1."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#delete_job/2","title":"ExGcloudPubsubPuller.Scheduler.delete_job/2","type":"function","doc":"Deletes a job by name Callback implementation for Quantum.Scheduler.delete_job/2."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#find_job/2","title":"ExGcloudPubsubPuller.Scheduler.find_job/2","type":"function","doc":"Resolves a job by name Callback implementation for Quantum.Scheduler.find_job/2."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#jobs/1","title":"ExGcloudPubsubPuller.Scheduler.jobs/1","type":"function","doc":"Returns the list of currently defined jobs Callback implementation for Quantum.Scheduler.jobs/1."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#new_job/1","title":"ExGcloudPubsubPuller.Scheduler.new_job/1","type":"function","doc":"Creates a new Job. The job can be added by calling add_job/1. Callback implementation for Quantum.Scheduler.new_job/1."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#start_link/1","title":"ExGcloudPubsubPuller.Scheduler.start_link/1","type":"function","doc":"Starts supervision and return {:ok, pid} or just :ok if nothing needs to be done. Returns {:error, {:already_started, pid}} if the repo is already started or {:error, term} in case anything else goes wrong. Options See the configuration in the moduledoc for options. Callback implementation for Quantum.Scheduler.start_link/1."},{"ref":"ExGcloudPubsubPuller.Scheduler.html#stop/2","title":"ExGcloudPubsubPuller.Scheduler.stop/2","type":"function","doc":"Shuts down the quantum represented by the given pid. Callback implementation for Quantum.Scheduler.stop/2."}]